/*
author: kaya*
Aby program zadziałał w odpowiednich miejscach należy podać własciwe dane.
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>


#define HOST "212.77.101.1"  // dla smtp.wp.pl - mozna wybrać dowolny serwer
#define PORT 25              // port SMTP - czasami może być inny należy sprawdzić w ustawieniach
#define MAX_DL 1024
#define MSG_LEN 1024

int main()
{
    struct sockaddr_in cel;
    int gniazdo = 0;
    int cs=0;
    char wiadomosc[1024];

    memset(&cel, 0, sizeof(cel));
    cel.sin_family = AF_INET;
    cel.sin_addr.s_addr = inet_addr(HOST);
    cel.sin_port=htons(PORT);

/*utworzenie gniazda*/
gniazdo = socket(AF_INET,SOCK_STREAM ,IPPROTO_TCP);
    if (gniazdo <0)
    {
        perror("socket");
        return 1;
        }

/*połączenie*/
cs=connect(gniazdo, (struct sockaddr*)&cel, sizeof(struct sockaddr) );
    if(cs<0)
    {
        close(gniazdo);
        perror("connect");
        return 1;
    }
printf ("wysylam.");

/*wysłanie komunikatu helo - bez tego też zadziała*/
if (send(gniazdo, "helo smtp.wp.pl\r\n", strlen("helo smtp.wp.pl\r\n"), 0) <0)
{
        close(gniazdo);
        perror("send");
        return 1;
}
printf ("..");

/*odebranie wiadomości od serwera*/
recv(gniazdo, wiadomosc, sizeof(wiadomosc),0);
memset(wiadomosc, 0, MSG_LEN);

/*wybór sposobu logowania - dostępne AUTH PLAIN lub LOGIN*/
if(send(gniazdo, "AUTH PLAIN\r\n", strlen("AUTH PLAIN\r\n"),0)<0)
{
        close(gniazdo);
        perror("send");
        return 1;
}
printf ("..");

/*odebranie informacji od serwera*/
recv(gniazdo, wiadomosc, sizeof(wiadomosc),0);
memset(wiadomosc, 0, MSG_LEN);

/*
wysłanie loginu i hasła zakodowanych base64
postać loginu i hasła - "\0login\0hasło"
do zakodowania wystarczy użyć Perla - perl -MMIME::Base64 -e 'print encode_base64("\0login\0haslo");'
*/
if (send(gniazdo, "tu podaj zakodowany login i hasło\r\n", strlen("tu podaj zakodowany login i hasło\r\n"),0)<0)//login i hasło zakodowane base64
{
        close(gniazdo);
        perror("send");
        return 1;
}
printf ("..");

/*odebranie wiadomości od serwera*/
recv(gniazdo, wiadomosc, sizeof(wiadomosc),0);
memset(wiadomosc, 0, MSG_LEN);

/*podanie adresu nadawcy - należy podać swój adres*/
send(gniazdo, "mail from: <nadawca@wp.pl>\r\n", strlen("mail from: <nadawca@wp.pl>\r\n"),0);
printf ("..");

/*odebranie wiadomości od serwera*/
recv(gniazdo, wiadomosc, sizeof(wiadomosc),0);
memset(wiadomosc, 0, MSG_LEN);

/*podanie adresu odbiorcy - należy podać właściwy adres*/
send(gniazdo, "rcpt to: <odbiorca@gmail.com>\r\n", strlen("rcpt to: <odbiorca@gmail.com>\r\n"),0);
printf ("..");

/*odebranie informacji od serwera*/
recv(gniazdo, wiadomosc, sizeof(wiadomosc),0);
memset(wiadomosc, 0, MSG_LEN);

/*wysłanie polecenia data - zaznacza, że nastąpi wpisanie wiadomości */
send(gniazdo, "data\r\n", strlen("data\r\n"),0);
printf ("..");

/*komunikat z serwera*/
recv(gniazdo, wiadomosc, sizeof(wiadomosc),0);
memset(wiadomosc, 0, MSG_LEN);

/*podanie nadawcy, odbiorcy i tematu maila*/
send(gniazdo, "From: nadawca <nadawca@wp.pl>\r\n", strlen("From: nadawca <nadawca@wp.pl\r\n>"),0);
printf ("..");

send(gniazdo, "To: odbiorca <odbiorca@gmail.com>\r\n", strlen("To: odbiorca <odbiorca@gmail.com>\r\n"),0);
printf ("..");

send(gniazdo, "Subject: Testowy mail\r\n", strlen("Subject: Testowy mail\r\n"),0);
printf ("..");

/*treść maila*/
send(gniazdo, "To jest wiadomość \r\n", strlen("To jest wiadomość \r\n"),0);
printf ("..");

/*wysłanie kropki oznacza zakończenie wprowadzania danych*/
send(gniazdo, ".\r\n", strlen(".\r\n"),0);
printf ("..");

recv(gniazdo, wiadomosc, sizeof(wiadomosc),0);
memset(wiadomosc, 0, MSG_LEN);

/*zakończenie wprowadzania danych - po nim nastąpi wysłanie maila*/
send(gniazdo, "quit\r\n", strlen("quit\r\n"),0);
printf ("..\n");

/*odebranie komunikatu od serwera*/
recv(gniazdo, wiadomosc, sizeof(wiadomosc),0);
memset(wiadomosc, 0, MSG_LEN);

/*zamknięcie połączenia i gniazda*/
close(cs);
close(gniazdo);
printf("Wysłane koniec! :)\n");


    return 0;
}
